-- Euphoria keywords and routines built in to ex.exe/exw.exe

global constant keywords = {
    "if", "end", "then", "procedure", "else", "for", "return",
    "do", "elsif", "while", "type", "constant", "to", "and", "or",
    "exit", "function", "global", "by", "not", "include",
    "with", "without", "xor"}

global constant builtins = {
    "length",   "puts",         "integer",      "sequence",     "position",
    "object",   "append",       "prepend",      "print",        "printf",
    "?",        "clear_screen", "floor",        "getc",         "gets",
    "get_key",  "rand",         "repeat",       "atom",         "compare",
    "find",     "match",        "time",         "command_line", "open",
    "close",    "trace",        "getenv",       "sqrt",         "sin",
    "cos",      "tan",          "log",          "system",       "date",
    "remainder","power",        "machine_func", "machine_proc", "abort",
    "peek",     "poke",         "call",         "sprintf",      "arctan",
    "and_bits", "or_bits",      "xor_bits",     "not_bits",     "pixel",
    "get_pixel","mem_copy",     "mem_set",      "c_proc",       "c_func",
    "routine_id","call_proc",   "call_func",    "poke4",        "peek4s",
    "peek4u",   "profile",      "equal",        "system_exec",  "platform"}

global constant library = {
    "all_palette",
    "allocate",
    "allocate_low",
    "allocate_string",
    "allow_break",
    "arccos",           -- 2.1
    "arcsin",           -- 2.1
    "atom_to_float32",
    "atom_to_float64",
    "bits_to_int",
    "bk_color",
    "bytes_to_int",
    "call_back",        -- 2.1?
    "chdir",            -- * 2.2
    "check_break",
    "crash_file",       -- * 2.2
    "crash_message",
    "current_dir",
    "cursor",
    "custom_sort",
    "define_c_func",
    "define_c_proc",
    "define_c_var",     -- * 2.2
    "dir",
    "display_image",
    "display_text_image",
    "dos_interrupt",
    "draw_line",
    "ellipse",
    "float32_to_atom",
    "float64_to_atom",
    "flush",            -- * 2.2
    "free",
    "free_console",     -- 2.1
    "free_low",
    "get",
    "get_active_page",
    "get_all_palette",
    "get_bytes",        -- 2.1
    "get_display_page",
    "get_mouse",
    "get_position",
    "get_screen_char",  -- * 2.2
    "get_vector",
    "graphics_mode",
    "instance",         -- 2.1
    "int_to_bits",
    "int_to_bytes",
    "lock_file",        -- * 2.2
    "lock_memory",
    "lower",
    "message_box",
    "mouse_events",
    "mouse_pointer",
    "open_dll",
    "palette",
    "PI",               -- 2.1 -- but should it be here?
    --"platform",       -- 2.1 -- moved in 2.2
    "polygon",
    "prompt_number",
    "prompt_string",    -- 2.1
    "put_screen_char",  -- * 2.2
    "read_bitmap",
    "register_block",   -- 2.1
    "reverse",          -- 2.1
    "save_bitmap",
    "save_image",
    "save_screen",
    "save_text_image",
    "scroll",
    "seek",
    "set_active_page",
    "set_display_page",
    "set_rand",
    "set_vector",
    "sleep",            -- * 2.2
    "sort",
    "sound",
    "sprint",           -- 2.1
    "text_color",
    "text_rows",
    "tick_rate",
    "unlock_file",      -- * 2.2
    "unregister_block", -- 2.1
    "upper",
    "use_vesa",
    "value",
    "video_config",
    "wait_key",
    "walk_dir",         -- 2.1
    "where",
    "wildcard_file",
    "wildcard_match",
    "wrap",

    -- The standard library files
    "dll.e",
    "file.e",
    "get.e",
    "graphics.e",
    "image.e",
    "machine.e",
    "misc.e",
    "mouse.e",
    "msgbox.e",
    "safe.e",
    "sort.e",
    "wildcard.e"}

global constant with_clauses = {
  --"profile", -- Also a builtin
    "profile_time",
  --"trace",   -- Also a builtin
    "type_check",
    "warning"}--,
    --"protected_script"} -- Saffi

global constant operators = {
	"+",
	"-",
	"=",
	"!"
	}