--Author: Toni koda  e-mail: tone.skoda@siol.net
--Created: 20. junij 2000 20:45, torek
--TSEu_ --euphoria source analyzing functions
--TSEuTxtLns_ : euphoria source analyzing functions
--				that work with lines of text

without warning
include Skoda\TSString.e
include Skoda\TSFile.e

object junk,ok
sequence DR_Includes,DR_Data

sequence DRP_Includes,DRP_Data,DRPL_Data,DRP_error

constant g_CurDir=current_dir()


--WARNING: ORDER MUSTN'T BE CHANGED!!
global constant subroutine = {"function","procedure","type"}


procedure error(sequence say)
	ok=message_box(say,"TSEu.ew Error",MB_OKCANCEL)
	if(ok=IDCANCEL) then abort(0) end if
	
end procedure

--retunrs: 
--1.word
--2.end of word or 0 if no found
--arg s: regular text
--arg p: here to start
--	CAUTION: p must be start of word
--arg incSpaces: if to overcome spaces
function TsEu_NextWord(sequence s,atom p,integer incSpaces)
	atom lens,i2,i
	sequence word
	lens=length(s)

	i=p
		
	--go word by word
	while i<lens and i>0 do		
        i2=TSWordGoToEdge_Eu2(s,i,1)    		
        
		if(i2>lens)then
			return{"",0}
		end if
        
		word=mid(s,i,i2)

		if incSpaces=0 then
			if AreJustSpaces(word)=0 then
				return{word,i2}
			end if
		else
			return{word,i2}
		end if

        i=i2+1

    end while
	
end function


--retunrs: 
--1.word
--2.start of word
--arg s: regular text
--arg p: here to start
--	CAUTION: p must be end of word
--arg incSpaces: if to overcome spaces
function TsEu_PrevWord(sequence s,atom p,integer incSpaces)
	atom lens,i2,i
	sequence word
	lens=length(s)

	i2=p
		
	--go word by word
	while i2<lens and i2>0 do
        i=TSWordGoToEdge_Eu2(s,i2,-1)		
        
        if(i2>lens)then
			exit
		end if

        word=mid(s,i,i2)

		if incSpaces=0 then
			if AreJustSpaces(word)=0 then
				return{word,i}
			end if
		else
			return{word,i}
		end if

        i2=i-1

    end while

end function

function GoToEdgeOfEuWord(sequence s,atom pos,atom way)

	atom lens,i,IscPart,prevIscPart,c
	--sequence c
	atom hasprev,hasnext,pprev,pnext,nm,p10
	sequence sret

	prevIscPart=false

	lens=length(s)
	i=pos

	c=s[i]

	if i<=1 then hasprev=0
	else hasprev=1
	end if

	if i>=length(s)then hasnext=0
	else hasnext=1 
	end if

	
--	--got to matching "
--		if s[pos]='"' then
--		    if way=-1 then
--				sret=TS_Str_GetQuotedStringBack(s,i-1)
--			else
--				sret=TS_Str_GetQuotedString(s,i+1)
--			end if
--			if sret[1]=1 then
--				return sret[3]			
--			end if
--		elsif s[pos]='-' then
--			if hasnext then
--				if s[pos+1]='-' then					
--					p10=matchfrom("\n",s,i)
--					if p10=0 then
--						p10=length(s)
--					else
--						p10-=2
--					end if
--
--					return p10+1
--				end if
--			end if
--		end if		

	while 1 do
		if(i<1 or i>lens)then
			if(prevIscPart=true)then i=i-way end if
			exit
		end if
		c=s[i]

		if i<=1 then hasprev=0
		else hasprev=1
		end if

		if i>=length(s)then hasnext=0
		else hasnext=1 
		end if
		
		if (hasprev=0) then pprev=0 else pprev=s[i-1] end if
		if (hasnext=0) then pnext=0 else pnext=s[i+1] end if
		IscPart=IsCharPartOfWord_Eu1(c,pprev,pnext,
			hasprev,hasnext)
		
		--'if not part of word then break, got
		--'to edge
		if(IscPart=false)then		
			--'if prev char is part of word go backone
			--'to stay within word
			if(prevIscPart=true)then
--				shown("i",i)
--				shown("way",way)
--				show("s[i]",s[i])
--				show("s[i+1]",s[i+1])
				i=i-way
--				ts("doing it")			
--				show("s[newi]",s[i])	
			end if			
--			ts("SENZA")
			exit
		end if
		
		prevIscPart=IscPart
		i=i+way
	end while

--	shown("i RET",i)
--	show("s[iret]",s[i])
	return i
end function




--INDEPENDENT
--returns: 
--1. word
--2. line number, 0 if not found
--3. col number of start of word
--arg s: lines of text
--arg ln,col: here to start
--	CAUTION: p must be end of word
--arg incSpaces: if to overcome spaces
global function TsEu_TxtLns_PrevWord(sequence s,
	atom begln,atom begcol,integer incSpaces)

	atom i2,i
	sequence word,linetext		
		
	--go word by word
	i2=begcol-1
	for line=begln to 1 by -1 do
		linetext=s[line]

		--ts("linetext="&linetext)

		if i2=-1 then
			i2=length(linetext)
		end if

		while i2<=length(linetext) and i2>0 do
		
        i=GoToEdgeOfEuWord(linetext,i2,-1)        
		--shown("i",i)

        word=mid(linetext,i,i2)
--		show("word",word)

		if incSpaces=0 then
			if AreJustSpaces(word)=0 then
				return {word,line,i}
			end if
		else
			return {word,line,i}
		end if

        i2=i-1
		end while		
		if incSpaces then
			return {"\n",begln-1,1}
		end if
		i2=-1

    end for
	return {"",0,0}
end function





--INDEPENDENT
--returns: 
--1. word
--2. line number, 0 if not found
--3. col number of END of word
--arg s: lines of text
--arg ln,col: here to start
--	CAUTION: p must be start of word
--arg incSpaces: if to return spaces as words
--	or to ignore them if 0
global function TsEu_TxtLns_NextWord(sequence s,
	atom begln,atom begcol,integer incSpaces)

	atom i2,i
	sequence word,linetext		
		
	--go word by word
	i2=begcol
--	NewDosTextColor()
--	shown("begcol",begcol)
--	shown("begln",begln)
	for line=begln to length(s) do
		linetext=s[line]

		--ts("linetext="&linetext)

		if i2=-1 then
			i2=1
		end if

		while i2<=length(linetext) and i2>0 do
		
        i=GoToEdgeOfEuWord(linetext,i2,1)
--		shown("i",i)

        word=mid(linetext,i2,i)
--		show("word",word)

		if incSpaces=0 then
			if AreJustSpaces(word)=0 then
				return {word,line,i}
			end if
		else
			return {word,line,i}
		end if		

        i2=i+1
		end while		
		if incSpaces then
			return {"\n",begln+1,1}
		end if
		i2=-1

    end for	
	return {"",0,begcol}
end function

--returns:
--current word, string, or "" if at wrong position
--char pos can be anywhere in word
global function TSEu_GetCurrentWordReel(sequence text,atom pos)
	atom endWord,startWord

	--if length(text)=0 then return{0,0} end if
	
	endWord=TSWordGoToEdge_Eu2(text,pos,1)
	startWord=TSWordGoToEdge_Eu2(text,pos,-1)	

	return mid(text,startWord,endWord)
end function

--returns:
--1.start of word
--2.end of word
--char pos can be anywhere in word
global function TSEu_GetCurrentWord(sequence text,atom pos)
	atom endWord,startWord

	--if length(text)=0 then return{0,0} end if
	
	endWord=TSWordGoToEdge_Eu2(text,pos,1)
	startWord=TSWordGoToEdge_Eu2(text,pos,-1)

	return{startWord,endWord}
end function


--retunrs: array
--1.argument type
--2.argument name
--handles comments if any in argument
--arg text: regular text
--arg p: first char of first in argumnet, its index in text
--	p (atom arg1,sequence arg2)
global function TSEu_GetFunctionArgumentsInRegularText(sequence text,atom p)
	atom lent
	sequence ret
	sequence nw
	integer switch	
	atom i
	integer iscomment
	sequence words

	words={}
	lent=length(text)
	switch=1
	iscomment=0
	ret={}

	i=p
	while i<lent do
		nw=TsEu_NextWord(text,i,0)
		if nw[2]=0 then
			exit 
		end if

		if equal(nw[1],")")then
			ret=append(ret,words)
			--showw("these two added",words)
			words={}
			exit
		elsif equal(nw[1],",")then
			ret=append(ret,words)
			--showw("these two added",words)
			words={}
		else
			--if comment
			if length(nw[1])>=2 then				
				if equal(nw[1][1..2],"--")then
					iscomment=1
				else
					iscomment=0
				end if
			else
				iscomment=0
			end if

			if iscomment=0 then
				words=append(words,nw[1])		
			end if
		end if

		--showw("nw[1]",nw[1])
		i=nw[2]+1
	end while

	return ret
end function



--DOESN'T WORK RIGHT?
--retunrs: array
--1.argument type
--2.argument name
--handles comments if any in argument
--arg s: lines of text
--arg begln,begcol: start line column, must be at first letter of first type
--	atom name - must be at position 'a' of 'atom'
--	mustnt be before or at '(' 
global function TSEu_GetFunctionArguments(sequence s,
	atom begln,atom begcol)

	atom lent
	sequence ret
	sequence nw
	integer switch	
	atom i
	integer iscomment
	sequence words
	atom line,column
	integer c
	sequence word,oneset
	integer at,prevc,doexit
	atom left_braces,right_braces

	ret={}	
	word=""
	oneset={}
	at=0 --1=type,2=name
	prevc=0
	line=begln
	left_braces=1
	right_braces=0
	doexit=0
	
	while line<=length(s) do	
		column=begcol
		while column<=length(s[line])do		
			c=s[line][column]
			--show("c",c)
			--wait()
			if isspace(c) then				
				oneset=append(oneset,word)
				word=""
			elsif c=',' then				
				oneset=append(oneset,word)
				word=""
				ret=append(ret,oneset)
				oneset={}
			elsif c='-' and prevc='-' then --comment
				exit
			elsif c=')' then
				right_braces+=1				
				if right_braces=left_braces then
					oneset=append(oneset,word)
					word=""
					ret=append(ret,oneset)
					oneset={}
					--show("exiting with ret",ret)
					doexit=1
					exit
				end if
			elsif c='(' then
				left_braces+=1
			else
				word&=c				
			end if
			prevc=c			
			column+=1
		end while
		if doexit then exit end if
		begcol=1

		line+=1
	end while
	
	return ret
end function




--returns 
--1.function name
--2.char index where function name *of text processed*
--3.line number *of text processed*
--4.column where function name *of text processed*
--5.'f'=function, 'p'=procedure
--6.'g'=global, 'l'=local
--7.arguments array, this format
--	1.argument type
--	2.argument name
--arg text: regular text
global function TSEu_GetRoutines(sequence text,sequence newLines)
	atom p1,p2,lent
	sequence linetext,ret
	atom t1,t2,lennl
	sequence key

	p1=1
	p2=1
	lent=length(text)
	ret={}
	lennl=length(newLines)

	t1=time()
	--go line by line
	for ln=1 to lennl-1 do
		linetext=text[newLines[ln]..newLines[ln+1]]
		--key = subroutine[i] & ' '
		--show("linetext",linetext)
	end for

	t2=time()
	shown("time",t2-t1)

	return ret

end function



global function get_subs2(sequence text)
	sequence ret,remaintext
	atom n1,i,numfound

	numfound=0
	i=-7
	ret={}
	
	while i<length(text) do		
		i=matchfrom("function",text,i+8)
		if i=0 then exit end if
		
		numfound+=1

	end while	

	shown("numfound",numfound)	

	return ret
end function


--rules (for speed) :
--1."global function name(" must be in one line
--	arguments can be in lines under or in same
--2. after "sub" must be ' ' = space, not tab or '\n'
--
--returns:
--array with:
--1.names
--2.start of sub, line number
--3.type of routine
--4.end of sub, line number
--
--arg startline: wfor ex.: where text was inserted, at which line
global function get_subs_smart( sequence text,sequence nl,
	atom startline)

    sequence list, sList, typeList, s, key, info
	sequence textline
    integer keyPress, n1, n2, typeofsub, pick
	atom endp
	sequence tmplist
	sequence END__SUB--text between "end" and sub
	atom cp
	sequence nw,pw
	integer startsub--0=dont know, -1=no,1 =yes	
	atom numfound
	integer srchStart --1=search start sub, 0=search end sub
	integer len_subroutine,lastnl
	atom chpaft_glob
	atom n1global
	atom len_text	
	integer foundfirst

	numfound=0
	startsub=0
	srchStart=1
	foundfirst=1

    -- intialize the lists
    list = {}       -- names and line numbers and type of routine    		
	
--	show("nl",nl)
	
	nl=prepend(nl,1)
	nl=append(nl,length(text))
	len_subroutine=length(subroutine)
	lastnl=length(nl)-1
	len_text=length(text)

	--shown("len_text",len_text)
	
	
    -- gather lists	

    for line = 1 to lastnl do	

	
	--if lastnl<10 then
--	shown("nl",nl)
--	end if
	textline=text[nl[line]..nl[line+1]]
	--if lastnl<10 then
--	show("textline",textline)
--	end if
	

		for i = 1 to len_subroutine do			  
			if srchStart then
				key=subroutine[i] & ' '
			else
				key= ' ' & subroutine[foundfirst]
			end if
		
			n1 = match(key, textline)	

			if n1 then
				if srchStart then --search start

					n2 = find('(', textline)

					typeofsub = match("global", textline)
					typeofsub = (typeofsub and typeofsub < n1) * 4 + i

					if n2 > n1 then						
						-- Get subname
						s = textline[n1+length(key)..n2-1]						

					    -- Strip spaces
					    while length(s) and s[1] = ' ' do
						s = s[2..length(s)]
						end while
						while length(s) and s[length(s)] = ' ' do
						s = s[1..length(s)-1]
						end while						
			
					    if length(s) then
						list  = append( list,  {s, line+startline-1,typeofsub} )
						srchStart=0
						foundfirst=i
						end if						
					end if					
					
					
					--chpaft_glob=n1+nl[line]-1 +length(subroutine[i])					
--					if chpaft_glob<=len_text then
--						if isspace(text[chpaft_glob])then
--							
--						end if
--					end if					
					
				else --search end
					endp=match("end ", textline)
					if endp and endp<n1 then
						--show("end!!!",textline)
						--showw("list bef",list)
						if length(list)then
							list[length(list)]&=line+startline-1
							--showw("list aft",list)
							srchStart=1
						end if
					end if
				end if

				numfound+=1
				exit --about 8% faster with this
			end if
	    
		end for	

    end for
	

    -- sort the list
--    sList = sort( sList )
  --  typeList = sList
--    for i = 1 to length(sList) do
--	show("sList[i]",sList[i])
--	shown("i",i)
--	typeList[i] = sList[i][2]
--	sList[i]    = sList[i][1]
  --  end for

--  for i=1 to length(list)do
--	show("list[i]",list[i])
  --end for

	--sort non case sensitive
  list=sort_no_case_sens(list)  

--  shown("numfound",numfound)
    

	return list
end function

--returns:
--array with:
--1.names
--2.start of sub line numbers
--3.type of routine
--4.end of sub line numbers
global function get_subs( sequence text,sequence nl)

    sequence list, sList, typeList, s, key, info
	sequence textline
    integer keyPress, n1, n2, typeofsub, pick
	atom endp
	sequence tmplist
	sequence END__SUB--text between "end" and sub
	atom cp
	sequence nw,pw
	integer startsub--0=dont know, -1=no,1 =yes	
	atom numfound
	
	numfound=0
	startsub=0

    -- intialize the lists
    list = {}       -- names and line numbers and type of routine    		
	
--	show("nl",nl)
	
	nl=prepend(nl,1)
	nl=append(nl,length(text))
	
	
    -- gather lists

    for line = 1 to length(nl)-1 do	

	textline=text[nl[line]..nl[line+1]]
	

		for i = 1 to length(subroutine) do			    
		
			n1 = match(subroutine[i], textline)	

			if n1 then
				--find out if start of sub or end:
				--IsSubStartOrEnd
				--find out if start of sub or end.
				numfound+=1
			end if
	    
		end for	

    end for

    -- sort the list
--    sList = sort( sList )
  --  typeList = sList
--    for i = 1 to length(sList) do
--	show("sList[i]",sList[i])
--	shown("i",i)
--	typeList[i] = sList[i][2]
--	sList[i]    = sList[i][1]
  --  end for

--  for i=1 to length(list)do
--	show("list[i]",list[i])
  --end for

	--sort non case sensitive
  --list=Sort(list)  

  shown("numfound",numfound)
    

	return list
end function


--returns index where in routEnds is previous 'end routine'
--arg curln: current line
--arg type=1(fun),2(proc),3(type)
global function TSEU_FindPREVRoutEnd_FromData(
	atom curln,sequence routEnds,atom rtype)

	for i=length(routEnds) to 1 by -1 do
		if routEnds[i][1]<curln 
			and remainder(routEnds[i][2],3)=rtype then

			return i
			
		end if
	end for

	return 0
end function


--returns index where in routEnds is next 'end routine'
--arg curln: current line
--arg type=1(fun),2(proc),3(type)
global function TSEU_FindNEXTRoutEnd_FromData(
	atom curln,sequence routEnds,atom rtype)

	sequence routEndsLns

	routEndsLns=routEnds[1]

--	shown("routEndsLns",routEndsLns)
--	shown("routEnds[2]",routEnds[2])
--	shown("routEnds",routEnds)

	for i=1 to length(routEndsLns)do
--		shown("routEndsLns[i]",routEndsLns[i])
--		shown("curln",curln)
--		shown("rtype",rtype)
--		shown("routEnds[2][i]",routEnds[2][i])
		if routEndsLns[i]>=curln
			and remainder(routEnds[2][i],3)=
				remainder(rtype,3) then				
				return i
		end if
	end for

	return 0
end function


--finds next routine start from data 'list'=routines data
--returns index where in 'list' next rout is, or 0 if none
global function TSEU_FindNEXTRoutineStart_FromData(
	sequence list,atom curln)

	for i=1 to length(list)do
		if list[i][1]>curln then
			return i
		end if
	end for

	return 0
end function


--finds previous routine start from data 'list'=routines data
--returns index where in 'list' previous routine is, or 0 if none
global function TSEU_FindPREVRoutineStart_FromData(
	sequence list,atom curln)

	for i=length(list) to 1 by -1 do
		if list[i][1]<=curln then
			return i
		end if
	end for

	return 0
end function


--NOT GOOD!!!
--returns index where in 'routEnds' or 0 if none found
--arg. i : for this routine searching end, member in 'list'
--arg list: local list
global function TSEU_FindEndOfRoutine_FromData(
	sequence list,
	atom i,
	sequence routEnds)

	atom start_next_rout,indEnd,next,
		main_type_cur_rout

	if i+1<=length(list)then
		start_next_rout=list[i+1][1]					
	else
		start_next_rout=0
	end if
	main_type_cur_rout=remainder(list[i][2],length(subroutine))

	shown("main_type_cur_rout",main_type_cur_rout)
	shown("start_next_rout",start_next_rout)

	next=list[i][1]

	while 1 do
		indEnd=TSSeqNumS_FindFirstBigger(
			routEnds[1],next)

--		shown("WWWindEnd",indEnd)

		if indEnd = 0 then
			return 0 
		end if		
		
		--if end is bigger than start of next
		if start_next_rout 
			and routEnds[1][indEnd]>start_next_rout then
			return 0
		end if

		--if same types
--		shown("main_type_cur_rout",main_type_cur_rout)
--		shown("ftype",remainder(routEnds[2][indEnd],length(subroutine)))
		if main_type_cur_rout=remainder(routEnds[2][indEnd],length(subroutine))then
			return indEnd
		end if		
		next=routEnds[1][indEnd]+1
	end while

	return 0
end function


--returns:
--1. index where in list found, 0 if not found
--1.
--global function TSEU_GetCurRout(sequence list,
--	sequence routEnds,atom ln)
--
--	
--	
--	return 0
--end function







--retunrs index where in lists PREVIOUS sub is or 0 if no previous sub exists
--arg list: got with function get_subs
--arg ln: current line number
-------------------------------------------------------------
global function TSEu_subs_GetPrev(sequence list,atom ln)
	--NewDosTextColor()
	for i=length(list) to 1 by -1 do
		if ln>list[i][1]then
			return i
		end if
	end for

	return 0
end function



--retunrs index where in lists NEXT sub is or 0 if no next sub exists
--arg list: got with function get_subs
--arg ln: current line number
-------------------------------------------------------------
global function TSEu_subs_GetNext(sequence list,atom ln)
	--NewDosTextColor()
	for i=1 to length(list) do
--		shown("list[i][1]",list[i][1])
--		shown("ln",ln)
--		wait()
		if list[i][1]>ln then
--			show("list[i]",list[i])
			return i
		end if
	end for

	return 0
end function

--INDEPENDENT
--returns :
--1. if found [0,1]
--2. include filename in text of line
--or "" if none
function GetIncludeFile(sequence textline,atom textline_len)
	atom pos,comm_found,nonspacepos,spacepos
	atom iss1,iss2

--	show("textline",textline)
--	shown("textline_len",textline_len)
--	wait()

	--get include files:
	pos=match("include",textline)
	if pos then
		--check if " include", not "Ainclude":
		if pos-1>=1 and isspace(textline[pos-1])=0 then
			return {0}
		end if

		if pos+7<=textline_len and isspace(textline[pos+7])=0 then
			return {0}
		end if
		--check if " include", not "Ainclude".

		--check if it's comment:
		comm_found=match("--",textline)
		if comm_found then
--			shown("comm_found",comm_found)
--			show("textline",textline)
			if comm_found<pos then
				return {0}
			end if
			textline=textline[1..comm_found]
		end if
		--check if it's comment.

		--check if in string:
		--!for now only support one string in line!
		iss1=find('"',textline)
		if iss1 then
			iss2=FindCharInString(textline,'"',iss1+1,1)
			if iss2!=-1 then				
				if pos> iss1 and pos<iss2 then
					return {0}
				end if
			end if
		end if
		--check if in string.

		nonspacepos=FindNONSpaceInString(textline,pos+8,1)
		if nonspacepos then			

			spacepos=FindSpaceInString(textline,nonspacepos,1)
			if spacepos=0 then			
				spacepos=textline_len+1
			end if

--			ts("include file is " &mid(textline,nonspacepos,spacepos))
--			wait()
			return {1,mid(textline,nonspacepos,spacepos-1)}
		else
			DRP_error&="syntax : after 'include' word no filename. " & " textline=" & textline & "\n"
		end if
	end if	
	--get include files.

	return {0}
end function



--INDEPENDENT
--returns :
--1. if found [0,1]
--2. include filename in text of line
--or "" if none
function GetIncludeFile_OBSOLETE(sequence textline,atom textline_len)
	atom pos,comm_found,nonspacepos,spacepos

	--get include files:
	pos=match("include",textline)
	if pos then
		--check if it's comment:
		comm_found=match("--",textline)
		if comm_found then
			if comm_found<pos then
				return {0}
			end if
			textline=textline[1..comm_found]
		end if
		--check if it's comment.
		nonspacepos=FindNONSpaceInString(textline,pos+8,1)
		if nonspacepos then
			spacepos=FindSpaceInString(textline,nonspacepos,1)
			if spacepos=0 then			
				spacepos=textline_len
			end if

--			ts("include file is " &mid(textline,nonspacepos,spacepos))
--			wait()
			return {1,mid(textline,nonspacepos,spacepos)}
		else
			DRP_error&="syntax : after 'include' word no filename\n"
		end if
	end if	
	--get include files.

	return {0}
end function




--NOT DONE
--use TSEu_GetFunctionArguments(s,pos) instead
--INDEPENDENT
--arg s : regular text
--arg pos : where to begine searching for head
--	must be before or at "(", but not before some other ")"
function GetFunctionHead(sequence s,atom pos)
	atom endp
	sequence ret
	sequence args
	ret={}

	--endp=TSStr_GetMatchingWord(s,
	--	"(",")",pos,1)

--	ts("word " & mid(s,pos,endp))

	--args=TSEu_GetFunctionArguments(s,pos)

	--show("args",args)

	return ret
end function


--gets euphoria directory path
global function TsEu_GetEuDir()
	object d
	d = getenv("EUDIR")
    if atom(d) then
		return "C:\\Euphoria"
	else
		return d
	end if
end function

--gets full name of include file
--first looka at current directory, then at  "euphoria\include" directory
--retunrs:
--1. success, 1 if file exists, 0 if dont
--2. full file path, if success
--
--argumnet name : can be also full path, then it will automatically open it
--	or just filename
--argument curdir : current path , in which directory
--	file that includes is, format: "c:\\euphoria"
global function TSEu_GetIncFileFullPath(sequence fname,sequence curdir)

--	if TSFile_exist(fname) then
--		return {1,fname}
--	end if

	if TSFile_exist(curdir & "\\" & fname) then
--		ts("curdir="&curdir)
--		ts("fname="&fname)		
		return {1,curdir & "\\" & fname}
	end if

	if TSFile_exist(TsEu_GetEuDir() &  "\\include\\" & fname) then
		return {1,TsEu_GetEuDir() &  "\\include\\" & fname}
	end if

	return {0}
end function


--major function which analyzes euphoria
--source code, for one file
--INDEPENDENT? must be
--rules (for speed) :
--1."global function name(" must be in one line
--	arguments can be in lines under or in same
--2. after "function" must be ' ' = space, not tab or '\n'
--
--RETURNS:
--1.global routine names
--
--2.global routine data
-- 1.start of sub, line number
-- 2.type of routine
--		1=local function
--		2=local procedure
--		3=local type
--		4=?
--		5=global function
--		6=global procedure
-- 3.arguments
--  array with:
--  1.argument type
--  2.argument name
--
--
--3.local routine names
--4.local routine data
--
--5.includes
-- 1. filename
-- 2. line number
--
--
--6.ends of routines
-- 1.sequence of line numbers
-- 2.sequence of types
--
--arg startline: wfor ex.: where text was inserted, at which line
global function TSEu_GetReport( sequence textLns,atom startline)

    sequence list, sList, typeList, s, key, info
	sequence textline
    integer keyPress, n1, n2, typeofsub, pick
	atom endp
	sequence tmplist
	sequence END__SUB--text between "end" and sub
	atom cp
	sequence nw,pw
	integer startsub--0=dont know, -1=no,1 =yes	
	atom numfound
	integer srchStart --1=search start sub, 0=search end sub
	integer len_subroutine	
	integer foundfirst	
	atom pos,spacepos,nonspacepos,textline_len
	sequence incfile,ret_includes			
	sequence args_begin
	sequence ret_routines	
	sequence ret_routinesData
	sequence loc_ret_routines	
	sequence loc_list
	atom numlines ,comm_match,str_match
	integer inComment,inString
	atom line,bytes,
		routStartBytePos --byte in text of firt letter of routine
	sequence ret_extraEnds,ret_endsRoutsLn,
	ret_endsRoutsType

	bytes=0

	startsub=0
	srchStart=1
	foundfirst=1
    
	ret_endsRoutsLn={}
	ret_endsRoutsType={}
    ret_routines={}
	ret_includes={}
	list={}

	loc_ret_routines={}	
	loc_list={}
	ret_extraEnds={}

	len_subroutine=length(subroutine)		
	numlines=length(textLns)	

	line=1
	while line<=numlines do
    --for line = 1 to numlines do	
		
	textline=textLns[line]
	textline_len=length(textline)	
	
	--get include files:
	incfile=GetIncludeFile(textline,textline_len)
	if incfile[1] then		
		ret_includes=append(ret_includes,{incfile[2],line+startline-1})		
	end if
	--get include files.

		--get routines:
		for i = 1 to len_subroutine do			  
			key=subroutine[i]
			n1 = match(key, textline)				

			if n1 then
				--looks like checking if in comment or string
				--take no time! at least not much!
				--it is only done for every found routine
				--and not for every line (BIG difference:-)

				--check if we are in comment:
				comm_match=match("--",textline)
				if comm_match and comm_match<n1 then
					inComment=true
				else
					inComment=false
				end if
				--check if we are in comment.

				--check if in string:
				if inComment=false then
					str_match=find('\"',textline)
					if str_match and str_match<n1 then
						inString=true
					else
						inString=false
					end if
				end if
				--check if in string.

				if inComment=false and inString=false then

				--if srchStart then --search start										

					n2 = find('(', textline)

					if(numlines<5)then
						--trace(1)
					end if

					typeofsub = match("global", textline)
					typeofsub = (typeofsub and typeofsub < n1) * 4 + i

					if n2=0 then
						--IS IT END?
						endp=match("end ", textline)
						if endp and endp<n1 then
							ret_endsRoutsLn=append(
								ret_endsRoutsLn,
								line+startline-1)
							ret_endsRoutsType=append(
								ret_endsRoutsType,
								typeofsub)
							srchStart=1
						end if
					else
					
					
					if n2 > n1 then
						-- Get subname						
						routStartBytePos=n1+length(key)
						s = textline[routStartBytePos..n2-1]						
						
						--routStartBytePos+=bytes-textline_len
						routStartBytePos+=bytes
	
					    -- Strip spaces
					    while length(s) and s[1] = ' ' do
						s = s[2..length(s)]
						routStartBytePos+=1
						end while
						--for i=length(s) to 1 by-1 do
--							if s[i]=' ' then
--								stripspaces_end=i
--								exit
--							end if
--						end for
						while length(s) and s[length(s)] = ' ' do
						s = s[1..length(s)-1]
						end while						
			
					    if length(s) then							
							srchStart=0
							foundfirst=i

							--get function head:LATER
							--ts("bef getting func head")
							--args_begin=TSTxtLns_FindNONSpace(textLns,line,n2+1)
							--shown("args_begin",args_begin)
							--ret_args=TSEu_GetFunctionArguments(textLns,args_begin[1],args_begin[2])
							--show("ret_args",ret_args)
							--wait()
							--get function head.

							
							if typeofsub >4 then --global
							
							
--							ts("global routine "&s)
--							if equal(s,"Dir95")then
--								wait()
--								show("ret_routines",ret_routines)
--								wait()
--							end if
--
--							if length(ret_routines)=0 then
--								wait()
--							end if

							ret_routines=append(ret_routines,s)
							list=append(list,
								{line+startline-1,typeofsub,routStartBytePos})
							else
--								ts("local routine "&s)								
								loc_ret_routines=append(loc_ret_routines,s)
								loc_list=append(loc_list,
									{line+startline-1,typeofsub,routStartBytePos})
							end if
--							wait()

						end if	
						end if					
					end if					

--				else --search end
--					
--							if typeofsub>4 then --global
--								list[length(list)]&=line+startline-1
--							else
--								loc_list[length(loc_list)]&=line+startline-1
--							end if
--							srchStart=1
--
--					--we found start of routine instead of end
--					--so we take it as here is the end of routine
--					else --must be start (syntax error)
--						line-=1 --everything claps!! :>)
--						if typeofsub>4 then --global
--							list[length(list)]&=list[length(list)][1]
--							 --line+startline-1
--						else
--							loc_list[length(loc_list)]&=loc_list[length(loc_list)][1]
--							 --line+startline-1
--						end if
--						srchStart=1												
--						ts("serr")
--						show("textline",textline)
--					end if
--				end if
				
				exit --about 8% faster with this
				end if --if inComment ...
--			else				
--				ts("NOT matched '" & key & "' in " & textline)
--				shown("line",line)
--				shown("i",i)
--				wait()
			end if --if n1
	    
		end for	
		--get routines.

		line+=1
		bytes+=textline_len+2 -- 2='\n'
    end while

--	--this handles syntax errors, end of routine is at end of text!
--	if srchStart=false then --still searchin end
--		if typeofsub>4 then --global
--			list[length(list)]&=list[length(list)][1]
--				--line+startline-1
--		else
--			loc_list[length(loc_list)]&=loc_list[length(loc_list)][1]
--				--line+startline-1
--		end if
--		srchStart=true
--	end if

	--sort non case sensitive
	--list=sort_no_case_sens(list)  
	
	return {ret_routines,	--1
		list,				--2
		loc_ret_routines,	--3
		loc_list,			--4
		ret_includes,		--5
		{ret_endsRoutsLn,ret_endsRoutsType}--6
		}
end function




--gets report for all files, also include
--sets global variables
--argument firstFile : if this is first file or one of includes [1,0]
procedure TSEu_GetDeepReport_Perfect(sequence path,
	sequence textLns,atom startline,integer firstFile)

	sequence ret,fullpath,path_dir,files,rep	

	--	NewDosTextColor()
--	ts("processed file " & path & "\n")
--	for i=1 to length(files)do
--		printf(1,"\n%s%d%s%s",{
--			"files ",
--			i,
--			"=",
--			files[i]
--			})
--	end for
--	wait()	

	
	if firstFile=0 then
		textLns=TSFile_ReadLines(path)		
	end if

	--path_dir=TSStr_File_GetDirectory(path)
      path_dir=(g_CurDir)
	rep=TSEu_GetReport(textLns,startline)

--	for i=1 to length(rep[5]) do
--		show("rep[5][i]",rep[5][i])
--	end for

	--save report for each file:
	if firstFile=0 then
--		ts("added inc " & path)
--		wait()
		DRP_Includes=append(DRP_Includes,path)
		DRP_Data=append(DRP_Data,rep)
	else
		DRPL_Data=rep		
--		show("rep[3]",rep[3])
--		shown("length(text)",length(text))
--		shown("strtline",startline)
--		show("rep",rep)
	end if
	--save report for each file.

	files=rep[5]
	if length(files)=0 then
		return
	end if		

--	show("files",files)
	
--this below works same as that more below
--	for i2=1 to length(files)do
--		junk=TSEu_GetIncFileFullPath(files[i2],path_dir)
--		if junk[1] then
--			Includes2=append(Includes2,lower(junk[2]))
--		end if
--	end for


	for i=1 to length(files)do
		fullpath=TSEu_GetIncFileFullPath(files[i][1],path_dir)
			--show("fullpath",fullpath)
			if fullpath[1] then				
				fullpath=lower(fullpath[2])		
--				ts("fullpath="&fullpath)
--				wait()
				if find(fullpath,DRP_Includes)=0 then
					--ts("Getting " & fullpath)
					TSEu_GetDeepReport_Perfect(fullpath,"",1,0)
				end if
			else
				DRP_error&="Can't open include file '" & files[i][1] & "' included in file '" &path & "'." &" path_dir=" & path_dir & "\n"
			end if
	end for	
end procedure


--gets data for text and for include files this text includes
--returns:
--1.data for this text, if path given, format of TSEu_GetReport return
--2.include files paths
--3.include files data, format of TSEu_GetReport return
--4.error text
--
--argument path : filepath of file in which this text is inserted
--THIS IS MAIN FUNCTION OF THIS FILE
global function TSEu_GetReport_Perfect(sequence path,
	sequence textLns,atom startline)
--{{{},{},{{G,e,t,M,d,i,s,E,d,i,t,w,n,d}},{{8,1,{},16}},{}},{},{}


	DRP_Includes={}
	DRP_Data={}
	DRPL_Data={}
	DRP_error=""
	TSEu_GetDeepReport_Perfect(path,textLns,startline,1)
	return {DRPL_Data,DRP_Includes,DRP_Data,DRP_error}
end function

--INDEPENDENT
--writes euphoria source analyzed data to
--EDS file format
--if previou
--arg filename : 
--arg source_fname : file path this data was extracted from
--arg g_rout : global routine names
--arg g_data : global routine data
--arg l_rout : global routine names
--arg l_data : global routine data
--arg includes : include file names
global procedure TSEu_WriteDataToEDSFile(sequence filename,
	sequence source_fname,
	sequence g_rout,
	sequence g_data,
	sequence l_rout,
	sequence l_data,
	sequence includes
	)



end procedure


--LATER!!!
--counts number of chars in text
--doesnt count characters in string -> ""
--arg. text : regular text
--arg. char : this char in text is count
--global function TSEu_GetFirstBrace(sequence text,integer char)
	
--end function



--INDEPENDENT
--text = normal text
--returns true if we are in string else false
global function TSEu_AreWeInString(sequence text,atom ourpos)
	atom start,lpos
	sequence qstr		

	lpos=0

	--start=find('\"',text) --first string with this function, is faster?!?!?
	while 1 do	
		--find first " of string		
--		shown("lpos",lpos)
		start=FindCharInString(text,'\"',lpos+1,1)		
--		shown("start",start)
		if start=-1 then
			return false
		end if
		if ourpos<start then
			return false		
		end if
		qstr=TS_Str_GetQuotedString(text,start+1)
		if qstr[1]=0 then
			return true
		elsif qstr[3]>ourpos then
			return true
		end if
		lpos=qstr[3]
	end while

	return false --never will get till here
end function





--INDEPENDENT
--returns sequence
--1. line where word found or 0 if not found
--2. column where word found, start
--3. length of found word
--arg s: here searching, LINES OF TEXT
--arg findtext: this text searcing, also can have wildcard
--arg to_line : max to this line searching
--	including this line
--	if -1 then searching till end/start of text
global function TsSearchTxtLns_FindText(sequence s,
	sequence findtext,
	integer match_whole_word,
	integer match_case,
	integer search_down, --[1(down),-1(up)]
	integer wild_card, --if wildcard match(1). if 0 then * and ? taken as litearlly
	atom from_line,
	atom from_col,
	atom to_line
	)

	atom pos
	atom prevpos
	sequence word	
	sequence word_lower
	sequence findtext_cmp
	sequence word_cmp
	sequence sslice,w
	atom found_len --length of found word
	sequence s_cmp,linetext,newWord_cmp
	atom foundln,foundcol
	integer wordsEqual

	foundln=0
	foundcol=0
	found_len=0	

	if to_line=-1 then
		to_line=length(s)
	end if

	
	--this must be else things get illogical,
	--think about it a little bit
	if wild_card then
		match_whole_word=1
	end if	
	
	if match_case=false then--if no case match
		findtext_cmp=lower(findtext)
	else
		findtext_cmp=findtext
	end if


	if match_whole_word then
		
		w={"",from_line,from_col-1}
		while 1 do

		--get word:
		if search_down=1 then		
			w=TsEu_TxtLns_NextWord(s,w[2],w[3]+1,true)
			if w[2]>to_line then
				return {0}
			end if
		else
			w=TsEu_TxtLns_PrevWord(s,w[2],w[3],true)
			if w[2]<to_line then
				return {0}
			end if
		end if
		if length(w[1])=1 and w[1][1]='\n' then
			w[3]-=1
		end if
		if w[2]=0 then
			exit
		end if
		if match_case then
			newWord_cmp=w[1]
		else
			newWord_cmp=lower(w[1])
		end if
--		show("worigin",w)
--		shown("w[2]",w[2])
--		shown("w[3]",w[3])
--		wait()		
		--get word.		

		--compare if equal:
		if wild_card then
			wordsEqual=wildcard_match(findtext_cmp,newWord_cmp)
		else
			wordsEqual=equal(findtext_cmp,newWord_cmp)
		end if
		if wordsEqual then
			foundln=w[2]
			if search_down=1 then
				foundcol=w[3]-length(newWord_cmp)+1
			else
				foundcol=w[3]
			end if
			found_len=length(newWord_cmp)
			exit
		end if		
		--compare if equal.					
		end while
		
	else	--if not match whole word ; easy		
		if search_down=1 then --search down			
			for i=from_line to to_line do
				if match_case then
					linetext=s[i]
				else
					linetext=lower(s[i])
				end if
				--show("linetext",linetext)
				if i=from_line then --first time
					foundcol=matchfrom(findtext_cmp,
						linetext,from_col)
				else					
					foundcol=match(findtext_cmp,linetext)
				end if
				if foundcol then
					foundln=i
					found_len=length(findtext_cmp)
					exit
				end if
			end for
		elsif search_down=-1 then --search up			
			for i=from_line to to_line by -1 do
				if match_case then
					linetext=s[i]
				else
					linetext=lower(s[i])
				end if
--				show("linetext",linetext)
				if i=from_line then --first time
	--				show("linetext",linetext)
	--				shown("from_col",from_col)
	--				show("findtext_cmp",findtext_cmp)					
					--WARNING: from_col is here sometimes one more than length(linetext), if it's at end of line
					foundcol=matchfromback(findtext_cmp,
						linetext,from_col)
				else
					--show("s[i]",s[i])	
					foundcol=matchfromback(findtext_cmp,linetext,length(linetext))
				end if
				if foundcol then					
					foundln=i					
					found_len=length(findtext_cmp)
					foundcol-=found_len-1
					exit
				end if
			end for
		end if
	end if
	
	return {foundln,foundcol,found_len}
end function




--INDEPENDENT
--gets arguemnts of function head
--(where function is declared, not used!)
--handles also if (right) brace
--is missing,
--words must be in that order:
--(t n,t n,t n)
--when this order is broken it stops counting it
--as part of head
--returns:
--1.sequences of: {1.arg type,2. arg name}
--2,3.ln,col where start of it, at '('
--4,5.ln,col where end of it, at last char of last arg name, not ')', since there may be no ')'
--
--arg sln,scol: here starting,
--	must be at or before first '('
--	when it finds first '(' it
--	starts considering it as function head
--
global function TsEuTxtLns_GetRoutArgsSmart(
	sequence txtlns,atom sline,atom scol)

	sequence ret,nw,tipe,word,prevword,nw2
	atom begln,begcol,prevln,
		start_ln,start_col,
		end_ln,end_col
	integer looking_for --'s'=space
						--'t'=type
						--'n'=name
						--','=comma
	integer init,incom


	begln=sline
	begcol=scol
	looking_for=0
	init=false	
	ret={}	
	tipe=""
	incom=false
	prevln=0
	prevword=""
	start_ln=0
	start_col=0
	end_ln=0
	end_col=0


	while 1 do
		nw= TsEu_TxtLns_NextWord(txtlns,
			begln,begcol,true)
		word=nw[1]

--		show("word",word)
		
		if nw[2]=0 then
			exit
		end if		

		--with every new line
		if nw[2]!=prevln then
			incom=false
		end if

--		show("word",word)
--		show("prevword",prevword)
		if equal(word,"-")then
			nw2= TsEu_TxtLns_NextWord(
				txtlns,nw[2],nw[3]+1,true)
			if nw2[2] and equal(nw2[1],"-")then
				incom=true
			end if
--			else
--				incom=false
		end if
		
		if incom=false then			

			if init=false and equal(word,"(")then
				init=true
				looking_for='t'
				start_ln=nw[2]
				start_col=nw[3]
			
			elsif init then
				if AreJustSpaces(word) and init then
					if length(tipe) then
						 looking_for='n'
					end if
					--if looking_for='s' then
						--looking_for='n'
					--else exit
					--end if
				elsif init and equal(word,",") and init then
					if looking_for=',' then
						looking_for='t'
					else exit
					end if
				else --not space or ","
					if TSStr_IsWordNormal(word) then
						if looking_for='t'	then
							tipe=word
							looking_for='s'
						elsif looking_for='n' then
							ret=append(ret,{tipe,word})
							tipe=""
							looking_for=','
						else exit
						end if
					else
						exit --not right type of
							--word, exiting premature
					end if
				end if
			end if
		end if --if not comment
		
		begln=nw[2]
		begcol=nw[3]+1
		end_ln=nw[2]
		end_col=nw[3]
		prevword=word
		prevln=nw[2]
	end while

	return {ret,start_ln,start_col,end_ln,end_col}
end function




--gets whole head of declared function,
--not function head we are using, but declaring!
--returns:
--1. line and col number of start of scope
--2. line and col number of end of scope
--3. is it global or local
--4. type :	where in subroutine constant 	(1='function',2='procedure',3='type')
--5. name
--6. arguments: {arg type,arg name,...}
--
--example:
--ln1: ... global function fn(atom a1
--ln2: 	atom a2)  ...
--would return {1,something},{2,something}
--
--arg ln,col : where is our position
--	from here looking forward and back
--	WARNING: MUSt be inside of routine name!
global function TSEuTxtLns_GetWholeDeclRoutHead(
	sequence txtlns,atom sline,atom scol)

	sequence headargs,pw,pw2,ret_name,cw
	atom ret_type,ret_glob,start_ln,start_col,
	end_ln,end_col

	ret_glob=0
	ret_type=0
	start_ln=0
	start_col=0
	end_ln=0
	end_col=0


	ret_name=TSEu_GetCurrentWordReel(txtlns[sline],scol)
	show("ret_name",ret_name)

	
	headargs=TsEuTxtLns_GetRoutArgsSmart(
		txtlns,sline,scol)
	
	end_ln=headargs[4]
	end_col=headargs[5]

	show("headargs",headargs)


	cw=TsEu_TxtLns_PrevWord(txtlns,
		sline,scol,false)
	show("cw",cw)

	pw=TsEu_TxtLns_PrevWord(txtlns,
		cw[2],cw[3]-1,false)
	show("pw",pw)
	ret_type=find(pw[1],subroutine)
	start_ln=pw[2]
	start_col=pw[3]

	if pw[2] then
		pw2=TsEu_TxtLns_PrevWord(txtlns,
			pw[2],pw[3]-1,false)

		start_ln=pw2[2]
		start_col=pw2[3]

		show("pw2",pw2)

		if equal(pw2[1],"global")then
			ret_glob=1
		else
			ret_glob=0
		end if
	else
		ret_glob=0
	end if

	ts("ia")


	return {
		{start_ln,start_col}--1
		,{end_ln,end_col}	--2
		,ret_glob			--3
		,ret_type			--4
		,ret_name			--5
		,headargs			--6
		}
end function


--returns line number where end found
--routType="function",...
global function TSEu_FindRoutEnd(
	sequence routType,
	sequence txtlns,
	atom startLn,atom endLn)

	atom n1,comm_match,str_match,n2
	sequence textline
	integer inComment,inString

	for line=startLn to endLn do
		textline=txtlns[line]
		n1=match(routType,textline)
		if n1 then
			n2=match("end",textline)
			if n2 then
				--check if we are in comment:
				comm_match=match("--",textline)
				if comm_match and comm_match<n1 then
					inComment=true
				else
					inComment=false
				end if
				--check if we are in comment.

				--check if in string:
				if inComment=false then
					str_match=find('\"',textline)
					if str_match and str_match<n1 then
						inString=true
					else
						inString=false
					end if
				end if
				--check if in string.

				if inComment=false and inString=false then
					return line
				end if
			end if
		end if
	end for

	return 0
end function


--INDEPENDENT
--formats path so that it's short as possible
--argument path : full path of  file
--argument curDir : default current firectory in which is file which includes all the paths
global function TSEu_FormatONEPath(sequence path,sequence curDir)
	sequence ret,euIncDir,incf
	atom curDir_len,euIncDir_len,incf_len
	integer incf_done

	ret={}
	curDir=lower(curDir)
	curDir_len=length(curDir)
	euIncDir=lower(TsEu_GetEuDir()  & "\\include\\")
	euIncDir_len=length(euIncDir)	

		incf=path
		incf_len=length(incf)
		incf_done=0

		if incf_len>=euIncDir_len then
			if equal(lower(incf[1..euIncDir_len]),euIncDir)then
				incf=mid(incf,euIncDir_len+1,incf_len)
				return incf
				incf_done=1
			end if
		end if

		if incf_done=0 and curDir_len>0 then
		if incf_len>=curDir_len then
			if equal(lower(incf[1..curDir_len]),curDir)then
				incf=mid(incf,curDir_len+1,incf_len)
				return incf
				incf_done=1
			end if
		end if
		end if	

	return path
end function



--INDEPENDENT
--formats paths so that they are short as possible
--argument paths : has paths
--arguemtn curDir : default current firectory in which is file which includes all the paths
global function TSEu_FormatPaths(sequence paths,sequence curDir)
	sequence ret,euIncDir
	atom curDir_len,euIncDir_len,incf_len
	integer incf_done	
	object incf

	ret={}
	curDir=lower(curDir)
	curDir_len=length(curDir)
	euIncDir=lower(TsEu_GetEuDir()  & "\\include\\")
	euIncDir_len=length(euIncDir)		

	for i=1 to length(paths) do
		incf=paths[i]
		
		if atom(incf)=0 then

		incf_len=length(incf)
		incf_done=0

		if incf_len>=euIncDir_len then
			if equal(lower(incf[1..euIncDir_len]),euIncDir)then
				incf=mid(incf,euIncDir_len+1,incf_len)
				ret=append(ret,incf)
				incf_done=1
			end if
		end if

		if incf_done=0 and curDir_len>0 then
		if incf_len>=curDir_len then
			if equal(lower(incf[1..curDir_len]),curDir)then
				incf=mid(incf,curDir_len+2,incf_len)				
				ret=append(ret,incf)
				incf_done=1
			end if
		end if
		end if
		
		end if
	end for

	return ret
end function



--INDEPENDENT
--reads slice of data of file
--from: 
--...
--function foo(atom a1,atom a2,
--	sequence s1,integer i)
--...
--returns:
--(atom a1,atom a2,
--	sequence s1,integer i)
function TsEu_ReadRoutineArguments(sequence fPath,atom bytepos)

	sequence ret,fs
	integer fn,c,incom,instr,prevc
	atom right,left

	ret="("

--	show("fPath",fPath)
--	show("routName",routName)
--	shown("bytepos",bytepos)

	fn=open(fPath,"r")
	if fn=-1 then
		error("TsEu_ReadRoutineArguments: can't open file " & fPath)
		return ""
	end if

	--get function head
	if seek(fn,bytepos) then
		error("TsEu_ReadRoutineArguments: seek(fn,bytepos)" & fPath)
	end if
	incom=false
	instr=false
	prevc=0
	right=0
	left=0
	while 1 do
		c=getc(fn)
		if c=-1 then exit end if
		--show("c",c)
		if left!=0 then
			ret&=c
		end if
		--string
		if c='\"' and prevc!= '\\' then
			if instr then
				instr=false
			else
				instr=true
			end if
		--comment
		elsif c='-' and prevc='-' and instr=false then
			incom=true
		elsif c='\n' then
			incom=false		
		elsif c='(' and instr=false and incom=false then
			left+=1
		elsif c=')' and instr=false and incom=false then
			right+=1
			if right>=left then
				exit
			end if
		end if
		prevc=c
	end while
	--fs=readFileSlice(fn,bytepos,bytepos+200)
	--show("fs",fs)

	return ret
end function

--returns "function",procedure" or "type", you input
--id 1-6
--		1=local function
--		2=local procedure
--		3=local type
--		4=?
--		5=global function
--		6=global procedure
global function TSEu_RoutNameFromId(integer id)
	if id=1 or id=5 then
		return "function"
	elsif id=2 or id=6 then	
		return "procedure"
	elsif id=3 then
		return "type"
	end if
end function