--FILE: TsIni.e
--AUTHOR: Tkoda tone.skoda@siol.net
--PURPOSE: functions to manipulate .ini file commands
--Created: 6. april 2000 17:07, etrtek
--Finished: 8. april 2000 18:34, sobota

include skoda\TSString.e
include skoda\TSDos.e

--main functions that came out of this file:
--TSIni_SortData --use it after read .ini file
--TSIni_DeSortData -- use it before writing to .ini file
--TSIni_WriteValue --write new values or rewrite old ones
--TSIni_ReadValue --read values
--main functions that came out of this file:


--.ini format is:
--[colors]
--main=0,100,0
--keyword=0,255,0
--
--[main]
--window position=10,20,300,400
--
--Structure of main sequence:
--(you dont need to know any of this shit to use main 4 functions,
-- only if ya wanna upgrade)
--s[1] has only titles
--length(s[1])=length(s[2])
--s[2][1] has names and values that are under title1(s[1][1])
--s[2][2] has names and values that are under title2(s[1][2])
--...
--Structure of main sequence.


------------------------------------------------------------------

procedure error(sequence say)
	ok=message_box(say,"TSIni.ew Error",0)
end procedure


--RETURNS index of first title (titles are save under s[1]) or 0 if not found
--you get 's' with function TSIni_SortData
function TSIni_FindTitle(sequence s,sequence title)
	for i=1 to length(s[1]) do
		if equal(s[1][i],title) then	return i end if
	end for

	return 0 --not found
end function


--RETURNS sequence: 2 indexes of first name under title or 0 if not found
--indexes:{titleindex,nameindex}
--
--you get 's' with function TSIni_SortData
--names are saved mixed with values
--to get value of name, use this: s[2][titleindex][nameindex+1]
function TSIni_FindName(sequence s,sequence title,sequence name)
	atom titleindex
	sequence ret
	ret={0,0}
		
	titleindex=TSIni_FindTitle(s,title)
	

	if titleindex=0 then return {0,0} end if

	--textoutwait("%s%d",{"\ntitleindex=",titleindex})

	--find name
	for k=1 to length(s[2][titleindex]) do
		if equal(name,s[2][titleindex][k]) then
			return {titleindex,k}
		end if
	end for

	return {titleindex,0} --not found
end function


--IT WORKS!
--use this function after you have read file
--s=file text
global function TSIni_SortData(sequence s)
	sequence ret,retglob,retmemb,w1,w2
	atom i,lens,i2,membnumG,p1,p2
	
	membnumG=0
	retglob={}
	retmemb={}
	ret=repeat(0,2)
	i=1
	lens=length(s)

	while i<lens do
		
		--found new [word]
		if s[i]='[' then
			i2=matchfrom("]",s,i)
			if i2=0 then exit end if

			retglob=append(retglob,s[i+1..i2-2])
			membnumG+=1
			retmemb=append(retmemb,0)
			retmemb[membnumG]={}

		--get both words that are around
		--word 1 = word 2
		elsif s[i]=	'=' then
			p1=matchfromback("\n",s,i)
			--if p1=0 then p1=1 end if

			p2=matchfrom("\n",s,i)
			if p2=0 then p2=lens+1 end if

---			msgboxm("%s%d%s%d%s%d%s%s",{
--			"p2=",p2,
--			"\np1=",p1,
--			"\ni=",i,
--			"\nw1=",s[p1+1..i-1]
--			})

			w1=TSStr_RemoveSpacesBE(s[p1+1..i-1])
			w2=TSStr_RemoveSpacesBE(s[i+1..p2-2])

--			msgboxm("%s%s%s%s%s%d",
--			{"\nw1=",w1,
--			"\nw2=",w2,
--			"\np2=",p2
--			})
			
			--save it in sequence
			retmemb[membnumG]=append(retmemb[membnumG],w1)
			retmemb[membnumG]=append(retmemb[membnumG],w2)
			
		end if

		i+=1
	end while



--test:
--it works!
--	for j=1 to length(retglob) do
--		dostextwait("%s%s",{"\nretglob[j]=",retglob[j]})
--		
--	end for
--
--	for k=1 to length(retmemb) do
--		for l=1 to length(retmemb[k]) do
--			dostextwait("%s%d%s%d%s%s",
--			{"\nretmemb[",k,"][",l,"]=",retmemb[k][l]})
--		end for
--	end for
--test.

	return {retglob,retmemb}

end function



--use this function to get text which you can write to file
global function TSIni_DeSortData(sequence s)
	sequence res
	atom globlen,memblen
	integer switch
	switch=1

	res=""

	if length(s)<2 then error("TSIni_DeSortData: s must have 2 sequences") end if

	globlen=length(s[1])
	memblen=length(s[2])	

	--each data and title (number of datas= number of tiltles)
	for i=1 to globlen do
		--textoutwait("%s%s",{"\ntitle=",s[1][i]})

		--title
		res&="\n\n[" & s[1][i] & "]"
		
		--each member of data=string
		for j=1 to length(s[2][i]) do
			switch=-switch
			if switch=-1 then --if label
				res&="\n" & s[2][i][j] & "="
			else --if value
				res&=s[2][i][j]
			end if
			--textout("\n%s%d",{"length(s[2][i][j])=",length(s[2][i][j])})
			--textoutwait("%s%d%s%s",
			--{"\ndata(s[2][",i,"])=",sequence_to_string(s[2][i][j])})
		end for
	end for
	
	return res

end function


--IT WORKS!
--RETURNS {1,new_s} if name under title already exists, else {0,new_s}
--writes new 'name'='value' under 'title'
--you get 's' with function TSIni_SortData
--'rewrite'= if 1 then rewrites existing value of 'name' under 'title'
--	else doesnt
global function TSIni_WriteValue(sequence s,sequence title,sequence name,sequence value,integer rewrite)
	sequence r2
	sequence ret
	ret={0,""}

	r2=TSIni_FindName(s,title,name)
	--if name under title DOES already exists
	if find(0,r2)=0 then
		ret[1]=1

		if rewrite =1 then
			--deb("rewritin")
			s[2][r2[1]][r2[2]+1]=value
		end if					

	--if name under title DOESNT exist, but title DOES exist
	--then insert two strings (new name and value)
	elsif r2[1]=1 and r2[2]=0 then
		--deb("alr exsit title")		

		--textoutswait(sequence_to_string(s[2][r2[1]]))

		s[2][r2[1]]=TSSeq_InsertSequence(s[2][r2[1]],{name},length(s[2][r2[1]])+1)
		s[2][r2[1]]=TSSeq_InsertSequence(s[2][r2[1]],{value},length(s[2][r2[1]])+1)

		--textoutswait(sequence_to_string(s[2][r2[1]]))

	--if name under title and title DONT exist
	--then create both at the end
	elsif r2[1]=0 and r2[2]=0 then
		--deb("title and name dont exist")
		s[1]=append(s[1],title)
		--deb(sequence_to_string(s[1]))

		s[2]=append(s[2],{name})
		s[2][length(s[2])]=append(s[2][length(s[2])],value)

		--deb(sequence_to_string(s[2]))

		--textoutswait("\n"&sequence_to_string(s[2][length(s[2])]))
	end if
	
	ret[2]=s

	return ret
end function


--IT WORKS!
--RETURNS : sequence {value,iffound}
	--iffound=1 if found, else 0 if not found
--reads value which has label 'name', name is under 'title'
global function TSIni_ReadValue(sequence s,sequence title,sequence name)
	sequence ret
	sequence ni

	ret={0,0}
	
	ni=TSIni_FindName(s,title,name)

	--if either title or name DOESNT exist
	if ni[1]=0 or ni[2]=0 then
		return {0,0}
	--if name and title DO exist
	else
		return {s[2][ni[1]][ni[2]+1],1}
	end if
		
end function

