--Created: 29. marec 2000 21:58, sreda
--Author: Tone koda  e-mail: tone.skoda@siol.net
--machine functions, low level
--appendix sometimes : TSMach_
--defined additional stuff that is not defined in C_Struct.e and machine.e 

include machine.e
include C_struct.e
--include Skoda\Error.ew

object ok,junk

global constant
--    Byte    = -1,
--    Word    = -2,
--    Integer = Word,
--    Long    = -3,
-- NEW! 0.45m renamed Dword to DWord
    DWord   = Long,
--	Dword   = Long,
-- NEW! 0.45f
    UInt    = Long,
--    Lpsz   = -4,  
-- NEW! 0.45m
    Ptr = Long

-->>
global function shiftRight(atom x, integer count)
  return floor(x / power(2, count))
end function

--(WORD (a)) | ((DWORD) ((WORD) (b))) << 16
--<<
global function shiftLeft(atom x, integer count)
  return x * power(2, count)
  --return floor(x * power(2, count))
end function

-----------------------------------------------------------------------------
--/topic Utilities
--/proc abortErr( message )
--/desc Display an error message, and abort.
--
-- Example:
--
--/code
--      abortErr( "Fatal error. Bummer, dude." )
--/endcode
---------------------------------------------------------------------------
global procedure abortErr( sequence s )                

    -- give message
    ok = message_box( s, "Win32Lib Error", MB_ICONHAND+MB_TASKMODAL )
    
    -- clean up  
--    if xCleanUp > -1 then
   --     call_proc( xCleanUp, {} )
--    end if
	trace(1)
ok = 1/0    
    -- abort
    abort(0)

end procedure




-----------------------------------------------------------------------------
sequence strings        -- stores addresses of strings used in topic Low Level Routines
strings = {}
-----------------------------------------------------------------------------
global function allot_string( sequence s )    

    -- allocate a string for a structure
    atom at
    
    -- place string in memory
    at = allocate_string( s )
    if at = 0 then
        -- out of string space
        abortErr( "Unable to allocate string space." )
    end if

    -- save location for garbage collection    
    strings = append( strings, at )
    
    -- return the address
    return at
    
end function


-- strings ------------------------------------------------------------------
-- allocate string that can be garbage collected later
global function AllocateString(object o)
	sequence strings
	strings = {}

    if atom(o) then
        return o
    end if
    strings = prepend(strings, allocate(length(o)+1))
    poke(strings[1], o&0)
    return strings[1]
end function

-- garbage collect strings
global procedure FreeString(sequence strings)
    for i = 1 to length(strings) do
        free(strings[i])
    end for
    strings = {}
end procedure

global function PeekString(atom a)
    integer i
    sequence s
    s = ""
    if a then
        i = peek(a)
        while i do
            s = append(s, i)
            a = a + 1
            i = peek(a)
        end while
    end if
    return s
end function

------------------------------------------------------------------ strings --



-- NEW! 0.45f
-----------------------------------------------------------------------------
--/topic Low Level Routines
--/func pack_word( low, high )
--/desc Packs values into word.
--/ret 32 bit word with low value in low 16 bits, high value in high 16 bits.
-- Typically used to encode a message parameter into a 32 bit word.
--
-- Example:
--
-- /code         
--      -- pack min and max into parameter
--      integer y
--      lParam = pack_word( min, max )
-- /endcode

global function pack_word( integer low, integer high )
    -- return packed 32 bit value
    
    -- mask values
    low  = and_bits( low,  #FFFF )
    high = and_bits( high, #FFFF )
    
    -- pack values
    return ( high * #10000 ) + low
    
end function


--returns size of type (1,2,4) or -1 if unsuccess
function TSMach_TypeSize(atom typ)		
	if typ=Byte then return 1
	elsif typ=Word or typ=Integer then return 2
	elsif typ=Long or typ=Dword or Lpsz then return 4
	end if

	return -1
end function

--returns size of struct( sums all types)
--or -1 if unsuccessful
function TSMach_StructSize(sequence types)
	atom r

	r=0
	
	for i=1 to length(types) do
		r+=TSMach_TypeSize(types[i])
	end for

	return r

end function

--It WORKS
--save sequence members to c struct
--returns atom addres of c sructure
--arg types: {Long,Byte,Word,Integer,Dword,Lpsz}
global function TSMach_EuStructToC(sequence eu,sequence types)
	atom address,offset

	offset=0
	address=allocate(TSMach_StructSize(types))

	
	for i=1 to length(types) do
		store(address,{offset,types[i]},eu[i])
		offset+=TSMach_TypeSize(types[i])
	end for


	return address
		
end function

--It WORKS
--save c struct members to sequence
--returns sequence that has members
--arg 'address' : address of c structure
--arg 'types': {Long,Byte,Word,Integer,Dword,Lpsz}

global function TSMach_CStructToEu(atom address,sequence types)
	atom offset
	sequence eu
	
	eu=repeat(0,length(types))

	offset=0

	
	for i=1 to length(types) do
		eu[i]=fetch(address,{offset,types[i]})
--		printf(1,"\n%s%d%s%d%s%d",{"fetching at offset ",offset,
--			"\n\ti=",i,
--			"\n\ttypes[i]=",types[i]
--			})
--		printf(1,"\n%s%d",{"eu[i]=",eu[i]})
--		printf(1,"\n%s%d",{"TSMach_TypeSize(types[i])=",TSMach_TypeSize(types[i])})
			
		offset+=TSMach_TypeSize(types[i])
	end for

	return eu
end function

--if string is:{97,111,102,0,3,43}
--returns {97,111,102}
global function TsMach_GetRealString(object s)
	atom p	
	p=find(0,s)	
	if p=0 then return s end if
	return s[1..p-1]
end function


---------------------------------------------------------------------------
global function LoWord(atom long)
        return remainder(long,65536)
end function

---------------------------------------------------------------------------
global function HiWord(atom long)
        return floor(long/65536)
end function

---------------------------------------------------------------------------
global function LOWORD(atom long)
        return remainder(long,65536)
end function

---------------------------------------------------------------------------
global function HIWORD(atom long)
        return floor(long/65536)
end function

global procedure pokew(atom addr,object w) -- poke word
    if atom(w) then
      poke(addr,{remainder(w,256),floor(w/256)})
    else
      for i = 1 to length(w) do
        poke(addr+(i-1)*2,{remainder(w[i],256),floor(w[i]/256)})
      end for
    end if
end procedure

global function peekw(object addr) -- peek word
sequence data
    if atom(addr) then
        return peek(addr)+peek(addr+1)*256
    else
      data = {}
      for i = 1 to addr[2] do
        data = data & peek(addr[1]+(i-1)*2)+peek(addr[1]+(i-1)*2)*256
      end for
      return data
    end if
end function

-- peek float
global function peekf(object o)
sequence data

  if atom(o) then
    return float64_to_atom(peek({o,8}))
  else
    data = {}
    for i = 1 to o[2] do
       data = data & float64_to_atom(peek({o[1]+(i-1)*8,8}))
     end for
  end if
  return data
end function

-- poke float
global procedure pokef(object addr, object data)
  if atom(data) then
    poke(addr,atom_to_float64(data))
  else
    for i = 1 to length(data) do
      poke(addr+(i-1)*8,atom_to_float64(data[i]))
    end for
  end if
end procedure


global function allocate_unicode(sequence string)
atom pUnicode
    pUnicode = allocate(2*length(string)+2)
    if not pUnicode then
        return 0
    end if
    pokew(pUnicode,string&0)
    return pUnicode
end function

global function peek_unicode(atom pUnicode)
sequence unicode
atom uchar
  unicode = {}
  if not pUnicode then return unicode end if
  uchar = peekw(pUnicode)
  while uchar do
    unicode = unicode & uchar
  end while
  return unicode  
end function

global function peeksz(atom pStr) -- peek string zero
-- return from allocated memory a string terminated by sero
integer c,i
sequence str
  
  str = {}
  i = 1
  c = peek(pStr)
  while c do
    str = str & c
    c = peek(pStr+i)
    i = i + 1
  end while
  return str
end function

global constant -- character set
  ANSI = 1,
  UNICODE = 2

-- return bytes needed to allocate a list of strings
global function ListLength(sequence list,integer charset)
integer count
  count = 0
  for i = 1 to length(list) do
    count = count + length(list[i]) + 1
  end for
  count = count + 1 
  if charset = ANSI then
    return count
  else
    return 2*count
  end if
end function

global procedure pokeStrList(atom pStr, sequence list,integer charset)
integer ofs
  ofs = 0
  if charset = ANSI then
    for i = 1 to length(list) do
      poke(pStr+ofs,list[i]&0)
      ofs = ofs + length(list[i]) + 1
    end for
    poke(pStr+ofs,0)
  else  
    for i = 1 to length(list) do
      pokew(pStr+ofs,list[i]&0)
      ofs = ofs + 2*length(list[i])+2
    end for
    pokew(pStr+ofs,0)
  end if
end procedure

global function peekStrList(atom pStr, integer charset)
integer c, ofs
sequence list, item

  list = {}
  item = {}
  ofs = 0
  if charset = ANSI then
    while 1 do
     c = peek(pStr+ofs)
     ofs = ofs + 1
     if not c then
        if length(item) = 0 then
            exit
        else
            list = list & {item}
            item = {}
        end if
     else
        item = item & c
     end if 
    end while
  else  
    while 1 do
     c = peekw(pStr+ofs)
     ofs = ofs + 2
     if not c then
        if length(item) = 0 then
            exit
        else
            list = list & {item}
            item = {}
        end if
     else
        item = item & c
     end if 
    end while
  end if 
  return list
end function

global function allocate_list(sequence list, integer charset)
atom pList
  pList = allocate(ListLength(list,charset))
  if not pList then
    return 0
  end if
  pokeStrList(pList,list,charset)
  return pList
end function

-- return next string position in allocated string list
global function NextStrOffset(atom ptr, integer charset)
atom ofs
  ofs = ptr
  if charset = ANSI then
    while peek(ofs) do
        ofs = ofs + 1
    end while
    return ofs + 1
  else  
    while peekw(ofs) do
        ofs = ofs + 2
    end while
    return ofs
  end if
end function




---#define MAKELANGID(p, s) ((((WORD) (s)) << 10) | (WORD) (p)) 
---------------------------------------------------------------------------
global function MAKELANGID(atom p,atom s)
	return or_all({shiftLeft(s,10),p})
end function


--(a) | (b)<<16
---------------------------------------------------------------------------
global function MAKELONG(atom a,atom b)
	return or_bits(a,shiftLeft(b,16))
end function

---------------------------------------------------------------------------
global function MAKELPARAM(atom a,atom b)
	return MAKELONG(a,b)
end function

---------------------------------------------------------------------------
global function RGB( integer r, integer g, integer b )
    
    -- return RGB value of triad
    return r + ( g * 256 ) + ( b * 256 * 256 ) 
    
end function 



-----------------------------------------------------------------------------
global function to_flag( atom a )

    -- return value based on truth of first arg
    
    if a then
        return 1
    
    else
        return 0

    end if
            
end function