--Created: 5. junij 2000 16:29, ponedeljek
--Author: Tone koda  e-mail: tone.skoda@siol.net
--purpose: math functions

include C_struct.e --abs() ...(?)

constant HalfPI = PI/2


--if positive or negative
--returns 1 or -1
global function NumberSign(atom num)
	if num<0 then return -1
	else return 1 end if
end function

--/topic Utilities
--/func abs( a )
--/desc Absolute value.
--/ret Absolute value of the atom.

--global function abs( atom a )
--    if a < 0 then
--        return -a
--    else
--        return a
--    end if
--end function


--rounds number
global function round(atom a)
	atom fl

	fl=floor(a)
	if abs(a-fl)<0.5 then return fl
	else return floor(a+NumberSign(a))
	end if
end function

global function IsPointInRect(atom x,atom y,
	atom x1,atom y1,atom x2,atom y2)
	
	if x<=x1 or x>= x2 or y<=y1 or y>=y2 then return false
	else return true end if
end function

global function IsPointInRectS(sequence point,
	sequence rect)
	
	if point[1]<=rect[1] or point[1]>=rect[3] 
		or point[2]<=rect[2] or point[2]>=rect[4] then return false
	else return true end if
end function

--includes borders, if point lies on borders of rect or in returns true
global function IsPointInRectIncS(sequence point,
	sequence rect)
	
	if point[1]<rect[1] or point[1]>rect[3] 
		or point[2]<rect[2] or point[2]>rect[4] then return false
	else return true end if
end function



global function Max(atom a, atom b)
    if a > b then
        return a
    else
        return b
    end if
end function


global function Min(atom a, atom b)
    if a < b then
        return a
    else
        return b
    end if
end function

--returns max number
global function max(sequence s)
	atom len
	atom maxiest

	len=length(s)

	if len=0 then
		printf(1,"\n%s",{"Error in max: s has no members"})
		return 0
	end if
	maxiest=s[1]	

	for i=1 to length(s) do
		if s[i]>maxiest then
			maxiest=s[i]
		end if
	end for

	return maxiest
end function

--returns min number
global function min(sequence s)
	atom len
	atom miniest

	len=length(s)

	if len=0 then
		printf(1,"\n%s",{"Error in min: s has no members"})
		return 0
	end if
	miniest=s[1]	

	for i=1 to length(s) do
		if s[i]<miniest then
			miniest=s[i]
		end if
	end for

	return miniest
end function


--sizes rc so that it's for percent smaller
--arg. percent : if 1 then returned same, if
--  0.5 then twice smaller etc
--arg. rc: has coordinates : left, top, right, bottom
--returns rectangle, zou have to round it with round()
--if zou want to use it as integer, cause they are floating
---------------------------------------------------------------------------
global function TS_ZoomRect(sequence rc,atom percent)
    atom centerx,centery,wid,hei

    
	wid=rc[3]-rc[1]
    hei=rc[4]-rc[2]
	
    centerx=rc[1]+(wid/2)
	centery=rc[2]+(hei/2)

	wid*=percent
	hei*=percent
	rc[1]=centerx-(wid/2)
	rc[2]=centery-(hei/2)
    rc[3]=centerx+(wid/2)
    rc[4]=centery+(hei/2)

--	rc[1]=round(rc[1])
--  rc[2]=round(rc[2])
--  rc[3]=round(rc[3])
--  rc[4]=round(rc[4])

    return rc
end function



--// Function name	 : CalcAngle
--// Time				:4.9.99 21:47:53
--// Description		: angle between 2 points
--//							it does matter which point is first and second
--//							returns angle in radians
--//							angle is always positive and between
--//							0 and 2*PI (0-360 degrees)
--// Return type	   : double - RADIANS
--// Argument           : int x1
--// Argument           : int y1
--// Argument           : int x2
--// Argument           : int y2
--not tested!
--NOT FINISHED
global function CalcAngle(integer x1,integer y1,integer x2,integer y2)
	atom dblAngle
	integer difx,dify
	
	difx=(x2-x1)
	dify=(y2-y1)	
	--todo
	dblAngle = arctan(dify/difx)
	if (dblAngle < PI/2)then
		dblAngle += 2 * PI
	elsif (dblAngle >= 2*PI)then
		dblAngle -= 2 * PI
	end if
	return dblAngle
end function


---------------- GetNiceAng ----------------
-- Routine: GetNiceAng
-- Type: function
-- Purpose: calculates angle between 2 points
-- Created: 13. December 2000, 23:43, Wednesday
-- Argument 1 = integer x1 : first x
-- Argument 2 = integer y1 : first y
-- Argument 3 = integer x2 : last x
-- Argument 4 = integer y2 : last y
--returns allways angle between 0-360 degrees, in radians
---------------- GetNiceAng  ----------------
global function GetNiceAng(integer x1,integer y1,integer x2,integer y2)
	integer difx,dify
	atom ang
	atom halfPI
	
	halfPI=PI/2
	
	difx=(x2-x1)
	dify=(y2-y1)
	
	if difx=0 then
		if y2<y1 then
			return PI+halfPI
		else
			return halfPI
		end if
	else
		ang= arctan(dify/difx)
	end if
	
	--return ang
	
	if dify=0 then
		if x2>x1 then
			return 0
		else
			return PI
		end if
	end if
	
	if ang<0 then
		if y2<y1 then
			ang=PI*2+ang
		else
			ang=PI+ang
		end if
	else
		if y2>y1 then
			ang=ang
		else
			ang=PI+ang
		end if
	end if
	
	return ang
end function

--converts degrees to radians
global function Rad(atom x)
	return x*PI/180
end function

--converts radians to degrees
global function Deg(atom x)
	return x*180/PI
end function

--get angle square
--returns:
--0 if none
--1 if upper right
--2 if upper left
--3 if lower left
--4 if lower right
--  2 | 1  
-- - -+- -
--  3 | 4
--
--arg .ang : has to be between 0-360 degrees, in radians
global function GetAngSq(atom ang)
	if ang<HalfPI then
		return 1
	elsif PI>ang and ang>HalfPI then
		return 2
	elsif PI+HalfPI>ang and ang>PI then
		return 3
	elsif 2*PI>ang and ang>PI+HalfPI then
		return 4
	end if
	
	return 0
end function
