--Created: 27. junij 2000 17:53, torek
--Author: Toni koda  e-mail: tone.skoda@siol.net
--purpose: TsSeqNum_ manipulate with sequnces that have numbers
--TsSeqNumS_: sorted numbers ascending: {1,6,8,9...}
--TSSeqNumLnCol: line and column routines, calculating ...

--counts numbers in sequence that are smaller
--or equal than arg 'num'
---------------------------------------------------------------------------
global function TsSeqNumS_CountSmaller(sequence s,atom num)
	atom ret
--	shown("s",s)
--	shown("num",num)
	ret =0
	for i=1 to length(s) do		
		if s[i]>=num then
			exit
		end if		
		ret=i		
	end for

	return ret
end function


--TESTED WORKS
--
--returns:
--1. index of last number that is smaler than num1
--2. index of first number that is bigger than num2
--
--examples:
--
--{1,5,10,15}
--num1=6
--num2=9
--returns:{2 (=5),3 (=10)}
--
--{1,5,10,15}
--num1=4
--num2=10
--
--returns: {1 (=1),3 (=10)}
--
--{1,5,10,15}
--num1=0
--num2=16
--
--returns:{0,0}
---------------------------------------------------------------------------
global function TsSeqNumS_GetBounds(
	sequence numbers,atom num1,atom num2)

	atom fi,li
	fi=0
	li=0
	
	for i=1 to length(numbers)do
		if num1>numbers[i] then
			fi=i
		end if
		
		if numbers[i]>num2 then
			li=i
			exit
		end if
	end for

	return {fi,li}
end function


--finds first bigger number than num in sorted sequence of numbers 's'
--returns index of that number in s or 0 if not found
---------------------------------------------------------------------------
global function TSSeqNumS_FindFirstBigger(sequence s,atom num)
	for i=1 to length(s)do
		if s[i]>num then return i end if
	end for
	return 0
end function



--finds first bigger or equal number than num in sorted sequence of numbers 's'
--returns index of that number in s or 0 if not found
---------------------------------------------------------------------------
global function TSSeqNumS_FindFirstBiggerOrEqual(sequence s,atom num)
	for i=1 to length(s)do
		if s[i]>=num then return i end if
	end for
	return 0
end function


--finds first smaller number than num in sorted sequence of numbers 's'
--returns index of that number in s or 0 if not found
---------------------------------------------------------------------------
global function TSSeqNumS_FindFirstSmaller(sequence s,atom num)
	for i=length(s) to 1 by -1 do
		if s[i]<num then return i end if
	end for
	return 0
end function


--finds first smaller or equal number than num in sorted sequence of numbers 's'
--returns index of that number in s or 0 if not found
---------------------------------------------------------------------------
global function TSSeqNumS_FindFirstSmallerOrEqual(sequence s,atom num)
	for i=length(s) to 1 by -1 do
		if s[i]<=num then return i end if
	end for
	return 0
end function

--lc: member 1 is line, member 2 is column
--returns 1 or two or 0 if same
---------------------------------------------------------------------------
global function TSSeqNumLnCol_GetSmaller(sequence lc1,sequence lc2)
	if lc1[1]<lc2[1] then
		return 1
	elsif lc1[1]=lc2[1] then
		if lc1[2]<lc2[2] then
			return 1
		elsif lc1[2]=lc2[2] then
			return 0 --same
		else
			return 2
		end if
	else
		return 2
	end if
end function
